//
//	ByteList.h
//
//	Created on: Dec 30, 2019
//      Author: vagner
//

#pragma once

#include <string>
#include <vector>

#include "vdef.h"

namespace vCommon
{

	class ByteList
	{
	public:

		//	ctor
		ByteList ( ) : bvec ( ) { }

		//	dtor
		virtual ~ByteList ( ) { bvec.clear ( ); }

		//	clear ( )
		void clear ( ) { bvec.clear ( ); }

		//	empty ( )
		bool empty ( ) { return bvec.empty ( ); }

		//	size ( )
		int size ( ) { return bvec.size ( ); }

		byte at ( int pos ) { return ( pos < 0 ) || ( pos >= size ( ) ) ? 0 : bvec [ pos ]; }

		//	compare
		bool compare ( byte* buf );

		//	list <= 8
		void push_8 ( byte value );

		//	list <= 16
		void push_16 ( u16 value );

		//	list <= u32
		void push_32 ( u32 value );

		//	list <= float
		void push_float ( float value );

        //  list <= string
        void push_string ( std::string& value );

        //  list <= buf
        void push_buf ( byte* buf, int bsize );

		//	pop_to => list
		void pop_list ( ByteList& dst );

		//	pop to => byte*
		void pop_buf ( byte* dst, int bsize );

		//	pop to => byte*
		void pop_buf ( byte* dst, int& offset, int bsize );

		//	вычислить CRC16
		u16 crc_16 ( );

		//	вычислить CRC32
		u32 crc_32 ( );

		//	buf
		std::vector<byte> bvec;
	};

} /* namespace vCommon */
