/*
 * dukHelper.h
 *
 *  Created on: Jun 26, 2017
 *      Author: vagner
 */

#pragma once

#include <regex.h>
#include <string>
#include <vector>

#include "duktape.h"

namespace vCommon
{

	class dukHelper
	{
	private:

		regex_t reg;

		//	Безопасное вычисление выражения.
		static duk_ret_t save_eval ( duk_context *ctx, void *udata );

		//	Безопасное преобразование результата к строке.
		static duk_ret_t save_tostring ( duk_context *ctx, void *udata );

	public:
		duk_context* ctx;

		//	ctor
		dukHelper ( );

		//	dtor
		~dukHelper ( );

		//	Вычислить выражение.
		bool eval ( const std::string& expr );

		//	Показать результат выражения.
		std::string show ( const std::string& expr );

		//	добавить параметр
		void add_param ( std::string& id, std::string& value );

		//	Получить список идентификаторов в выражении.
		std::vector <std::string> getIdList ( const std::string& expr );
	};

} /* namespace vCommon */
