/*
 * vXml.h
 *
 *  Created on: Jun 14, 2017
 *      Author: vagner
 */

#pragma once

#include <string>

#include "pugixml.h"

namespace vCommon
{
	//
	//	Обертка работы с XML.
	//
	class vXml
	{
	private:
		pugi::xml_document xdoc;		//	XML документ
	public:
		//
		//	ctor
		//
		vXml ( );
		//
		//	Получить первого потомка с указанным именем.
		//
		static pugi::xml_node Child ( const pugi::xml_node& Parent, const std::string& ChildName );
		//
		//  ChildString
		//
		static std::string ChildString ( const pugi::xml_node& node, const std::string& ChildName, const std::string& def = "" );
		//
		//  ChildBool
		//
		static bool ChildBool ( const pugi::xml_node& node, const std::string& ChildName, bool def );
		//
		//  ChildInt
		//
		static int ChildInt ( const pugi::xml_node& node, const std::string& ChildName, int def );
		//
		//  ChildDouble
		//
		static double ChildDouble ( const pugi::xml_node& node, const std::string& ChildName, double def );
		//
		//	Root
		//
		inline pugi::xml_node Root ( )
		{
			return xdoc.root ( );
		}
		//
		//	Загрузить файл.
		//
		bool Load ( const std::string& FileName );
		//
		//	Сохранить файл.
		//
		bool Save ( const std::string& FileName );
		//
		//	Установить значение указанного потомка.
		//
		static bool setChildValue ( pugi::xml_node parent, const std::string& ChildName, const std::string& Value );
	};

} /* namespace vCommon */
